package datastructures;

import java.util.LinkedList;

public class BeperkteQueue<E>
{
	private LinkedList<E> queue;
	private final int maxOmvang;
	private int omvang;
	
	public BeperkteQueue(int maxOmvang)
	{
		this.maxOmvang = maxOmvang;
		queue = new LinkedList<E>();
	}
	
	public void add(E element)
	{
		if(omvang < maxOmvang)
		{
			queue.addLast(element);
			omvang++;
		}
		else
		{
			remove();
			queue.addLast(element);
		}
	}
	
	/**
	 * Probeert een element te verwijderen, maar retourneert null als de queue leeg is.
	 * @return
	 */
	public E remove()
	{
		if(omvang>0)
		{
			omvang--;
			return queue.removeFirst();
		}
		else
		{
			return null;
		}
	}

	public int getOmvang() {
		return omvang;
	}

	public int getMaxOmvang() {
		return maxOmvang;
	}

	public LinkedList<E> getQueue() {
		return queue;
	}
}
