package datastructures;

public class ZoekBoom<K extends Comparable<K>, V> 
{
	private Knoop<K, V> wortel;
	private int size;
	
	public ZoekBoom()
	{
		wortel = null;
		size = 0;
	}
	
	public void add(K key, V value)
	{
		if(wortel == null)
		{
			wortel = new Knoop<K, V>(key, value, null, null);
			size++;
		}
		else
		{
			Knoop<K, V> huidig = wortel;
			boolean geplaatst = false;
			while(!geplaatst)
			{
				if(key.compareTo(huidig.getKey()) <= 0)
				{
					// key is kleiner/gelijk aan huidig.getKey()
					if(huidig.getLinks() == null)
					{
						huidig.setLinks(new Knoop<K, V>(key, value, null, null));
						size++;
						geplaatst = true;
					}
					else
					{
						huidig = huidig.getLinks();
					}
				}
				else
				{
					// key is groter aan huidig.getKey()
					if(huidig.getRechts() == null)
					{
						huidig.setRechts(new Knoop<K, V>(key, value, null, null));
						size++;
						geplaatst = true;
					}
					else
					{
						huidig = huidig.getRechts();
					}
				}
			}
		}
	}
	
	public V remove(K key)
	{
		if(size == 0)
			return null;
		else
		{
			if(wortel.getKey().compareTo(key) == 0)
			{
				if(size == 1)
				{
					V temp =  wortel.getValue();
					wortel = null;
					size--;
					return temp;
				}
				else
				{
					// zoek de knoop rechtsonderin de linker deelboom
					Knoop<K, V> nieuweKnoop = wortel.getLinks();
					Knoop<K, V> dummyKnoop = wortel;
					
					if(nieuweKnoop!=null)
					{
						while(nieuweKnoop.getRechts()!= null)
						{
							dummyKnoop = nieuweKnoop;
							nieuweKnoop = nieuweKnoop.getRechts();
						}
						// verwijder de knoop rechtsonderin de linker deelboom en maak die de nieuwe wortel
						if(wortel.getLinks() == nieuweKnoop)
						{
							nieuweKnoop.setRechts(wortel.getRechts());
						}
						else
						{
							dummyKnoop.setRechts(null);
							nieuweKnoop.setLinks(wortel.getLinks());
							nieuweKnoop.setRechts(wortel.getRechts());
						}
						
						V temp = wortel.getValue();
						wortel = nieuweKnoop;
						size--;
						return temp;
					}
					else
					{
						nieuweKnoop = wortel.getRechts();
						V temp = wortel.getValue();
						wortel = nieuweKnoop;
						size--;
						return temp;
						
					}
				}
			}
			else
			{
				// zoek de knoop die we willen verwijderen
				Knoop<K, V> gezochteKnoop = wortel;
				Knoop<K, V> parentKnoop = wortel;
				boolean gevonden = false;
				while(!gevonden)
				{
					if(key.compareTo(gezochteKnoop.getKey()) == 0)
					{
						gevonden = true;
					}
					else if(key.compareTo(gezochteKnoop.getKey()) < 0)
					{
						parentKnoop = gezochteKnoop;
						if(gezochteKnoop.getLinks() == null)
						{
							return null;
						}
						else
						{
							gezochteKnoop = gezochteKnoop.getLinks();
						}
					}
					else
					{
						// key is groter aan huidig.getKey()
						parentKnoop = gezochteKnoop;
						if(gezochteKnoop.getRechts() == null)
						{
							return null;
						}
						else
						{
							gezochteKnoop = gezochteKnoop.getRechts();
						}
					}
				}
				
				// zoek de knoop rechtsonderin de linker deelboom
				Knoop<K, V> nieuweKnoop = gezochteKnoop.getLinks();
				Knoop<K, V> dummyKnoop = gezochteKnoop;
				
				if(nieuweKnoop!=null)
				{
					while(nieuweKnoop.getRechts()!= null)
					{
						dummyKnoop = nieuweKnoop;
						nieuweKnoop = nieuweKnoop.getRechts();
					}
					// verwijder de knoop rechtsonderin de linker deelboom en maak die de nieuwe wortel
					if(gezochteKnoop.getLinks() == nieuweKnoop)
					{
						nieuweKnoop.setRechts(gezochteKnoop.getRechts());
					}
					else
					{
						dummyKnoop.setRechts(null);
						nieuweKnoop.setLinks(gezochteKnoop.getLinks());
						nieuweKnoop.setRechts(gezochteKnoop.getRechts());
					}
					
					V temp = gezochteKnoop.getValue();
					
					if(parentKnoop.getLinks() == gezochteKnoop)
						parentKnoop.setLinks(nieuweKnoop);
					else if(parentKnoop.getRechts() == gezochteKnoop)
						parentKnoop.setRechts(nieuweKnoop);
					else
						System.out.println("parent klopt niet");
					size--;
					return temp;
				}
				else
				{
					nieuweKnoop = gezochteKnoop.getRechts();
					V temp = gezochteKnoop.getValue();
					if(parentKnoop.getLinks() == gezochteKnoop)
						parentKnoop.setLinks(nieuweKnoop);
					else if(parentKnoop.getRechts() == gezochteKnoop)
						parentKnoop.setRechts(nieuweKnoop);
					else
						System.out.println("parent klopt niet");
					size--;
					return temp;
				}
			}
		}
	}

	public int getSize() 
	{
		return size;
	}
}
