package io;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import types.Dienst;
import types.Diensten;
import types.Tijdstip;

public class DienstenParser
{
	private BufferedReader reader;

	/**
	 * Maakt deze parser klaar om diensten uit het gegeven bestand te gaan
	 * lezen.
	 * 
	 * @param dienstenFile
	 *            bestand waarin de diensten zich bevinden
	 * @throws FileNotFoundException
	 *             als het dienstenbestand niet gevonden kan worden
	 */
	public DienstenParser(File dienstenFile) throws FileNotFoundException
	{
		reader = new BufferedReader(new FileReader(dienstenFile));
	}

	/**
	 * Leest de diensten uit het in de constructor gespecificeerd bestand.
	 * 
	 * @return een linked list met daarin alle ingelezen diensten
	 * @throws IOException
	 *             als het dienstenbestand niet te lezen was
	 */
	public Diensten leesDiensten() throws IOException
	{
		Diensten diensten = new Diensten();

		for (String dienstRegel = reader.readLine(); dienstRegel != null; dienstRegel = reader
				.readLine())
		{
			String[] splitted = dienstRegel.split(",");
			String[] startSplit = splitted[3].split(":");
			String[] eindSplit = splitted[4].split(":");
			String[] lengteSplit = splitted[5].split(":");
			diensten.add(new Dienst(Integer.parseInt(splitted[0]), splitted[1]
					.charAt(0), Integer.parseInt(splitted[2]), new Tijdstip(
					Integer.parseInt(startSplit[0]), Integer
							.parseInt(startSplit[1])), new Tijdstip(Integer
					.parseInt(eindSplit[0]), Integer.parseInt(eindSplit[1])),
					new Tijdstip(Integer.parseInt(lengteSplit[0]), Integer
							.parseInt(lengteSplit[1]))));
		}
		return diensten;
	}
}
