package io;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Map;

import types.Dienst;
import types.DienstRooster;
import types.RoosterIndeling;

public class RoosterIndelingWriter 
{
	BufferedWriter outputFile;
	
	public RoosterIndelingWriter(File file) throws IOException
	{
		outputFile = new BufferedWriter(new FileWriter(file));
	}
	
	public void schrijf(RoosterIndeling roosterIndeling) throws IOException
	{
		for(Map.Entry<Integer, DienstRooster> entry : roosterIndeling.iterator())
		{
			int roosterNummer = entry.getKey();
			Dienst[][] dienstRooster = entry.getValue().getDienstRooster();
			for(int regelTeller=0; regelTeller < dienstRooster[0].length; regelTeller++)
			{
				for(int dagTeller=0; dagTeller < dienstRooster.length; dagTeller++)
				{
					Dienst dienst = dienstRooster[dagTeller][regelTeller];
					if(dienst.isVrij())
					{
						outputFile.write(roosterNummer + "," + regelTeller + "," + dagTeller 
								+ ",,VRIJ,,," );
					}
					else
					{
						outputFile.write(roosterNummer + "," + regelTeller + "," + dagTeller + ","
						+ dienst.getDienstType() + "," + dienst.getDienstNummer() + "," + 
						dienst.getBeginTijd().toString() + "," + dienst.getEindTijd().toString() 
						+ "," + dienst.getDienstLengte().toString());
					}
					outputFile.newLine();
				}
			}
		}
		outputFile.flush();
	}
}
