package types;


public class Dienst
{
	private int dagNummer;

	private char dienstType;

	private int dienstNummer;

	private Tijdstip beginTijd;

	private Tijdstip eindTijd;

	private Tijdstip dienstLengte;

	/**
	 * Maakt een reguliere dienst aan.
	 * @param dagNummer
	 * @param dienstType
	 * @param dienstNummer
	 * @param beginTijd
	 * @param eindTijd
	 * @param dienstLengte
	 */
	public Dienst(int dagNummer, char dienstType, int dienstNummer,
			Tijdstip beginTijd, Tijdstip eindTijd, Tijdstip dienstLengte)
	{
		this.dagNummer = dagNummer;
		this.dienstType = dienstType;
		this.dienstNummer = dienstNummer;
		this.beginTijd = beginTijd;
		this.eindTijd = eindTijd;
		this.dienstLengte = dienstLengte;
	}
	
	/**
	 * Maakt een dienst aan die een vrije dag representeert.
	 * @param dagNummer
	 */
	public Dienst(int dagNummer)
	{
		this.dagNummer = dagNummer;
		this.dienstNummer = Integer.MIN_VALUE;
		this.dienstLengte = new Tijdstip(0, 0);
	}
	
	public boolean isVrij()
	{
		return dienstNummer == Integer.MIN_VALUE;
	}

	public Tijdstip getBeginTijd()
	{
		return beginTijd;
	}

	public void setBeginTijd(Tijdstip beginTijd)
	{
		this.beginTijd = beginTijd;
	}

	public int getDagNummer()
	{
		return dagNummer;
	}

	public void setDagNummer(int dagNummer)
	{
		this.dagNummer = dagNummer;
	}

	public Tijdstip getDienstLengte()
	{
		return dienstLengte;
	}

	public void setDienstLengte(Tijdstip dienstLengte)
	{
		this.dienstLengte = dienstLengte;
	}

	public int getDienstNummer()
	{
		return dienstNummer;
	}

	public void setDienstNummer(int dienstNummer)
	{
		this.dienstNummer = dienstNummer;
	}

	public char getDienstType()
	{
		return dienstType;
	}

	public void setDienstType(char dienstType)
	{
		this.dienstType = dienstType;
	}

	public Tijdstip getEindTijd()
	{
		return eindTijd;
	}

	public void setEindTijd(Tijdstip eindTijd)
	{
		this.eindTijd = eindTijd;
	}
}
