package types;

import java.util.Map;
import java.util.TreeMap;

/**
 * Bewaart roosterindelingen op basis van hun roosternummer.
 * @author Pieter van Ede
 */
public class RoosterIndeling
{
	private TreeMap<Integer, DienstRooster> roosterIndeling;
	private int[]roosternrs;



	public RoosterIndeling() {
		roosterIndeling = new TreeMap<Integer, DienstRooster>();
		
	}

	/**
	 * Krijg een roosterindeling voor het gegeven rooster nummer.
	 * @param roosterNummer
	 * @return
	 */
	public DienstRooster getRoosterIndeling(int roosterNummer) {
		return roosterIndeling.get(roosterNummer);
	}

	/**
	 * Voeg een roosterindeling behorend bij het roosternummer toe.
	 * @param roosterNummer
	 * @param dienstRooster
	 */
	public void addRoosterIndeling(int roosterNummer, DienstRooster dienstRooster) {
		roosterIndeling.put(roosterNummer, dienstRooster);
	}
	
	public void setRoosternrs(int[] roosternrs) 
	{
		this.roosternrs = roosternrs;
	}

	public int[] getRoosternrs() {
		return roosternrs;
	}
	
	public double getKosten()
	{
		double kosten = 0;
		for(int i=0; i<roosternrs.length;i++)
		{
			kosten+= getRoosterIndeling(roosternrs[i]).getKosten();
		}
		return kosten;
	}
	
	public Iterable<Map.Entry<Integer, DienstRooster>> iterator()
	{
		return this.roosterIndeling.entrySet();
	}
}
