package types;

public class Tijdstip
{
	private int minuut;

	private int uur;

	public Tijdstip(int uur, int minuut)
	{
		this.uur = uur;
		this.minuut = minuut;
	}

	public int getMinuut()
	{
		return minuut;
	}
	
	public int naarMinuten()
	{
		return 60*uur + minuut;
	}

	public void setMinuut(int minuut)
	{
		this.minuut = minuut;
	}

	public int getUur()
	{
		return uur;
	}

	public void setUur(int uur)
	{
		this.uur = uur;
	}
	
	public String toString()
	{
		String result = uur + ":";
		if(minuut<9)
			result += "0"+minuut;
		else
			result += minuut;
		return result;
	}
	
	public Tijdstip verschilTussenTijdstippen(Tijdstip eind)
	{
		int verschilInMinuten = (60*uur+minuut) - eind.naarMinuten();
		if(verschilInMinuten>=0)
		{
			int uren = verschilInMinuten/60;
			int minuten = verschilInMinuten%60;
			return new Tijdstip(uren, minuten);
		}
		else
		{
			int eindeDagMinEindeDienst = 1440-eind.naarMinuten();
			verschilInMinuten = eindeDagMinEindeDienst+(60*uur+minuut);
			int uren = verschilInMinuten/60;
			int minuten = verschilInMinuten%60;
			return new Tijdstip(uren, minuten);
		}
	}
	
	public Tijdstip minus(Tijdstip eind)
	{
		int verschilInMinuten = (60*uur+minuut) - eind.naarMinuten();
		int uren = verschilInMinuten/60;
		int minuten = verschilInMinuten%60;
		return new Tijdstip(uren, minuten);
	}
}
